<?php
/**
*
* @package - "Automatic Daylight Savings Time 2"
* @version $Id: convert_timezones.php 3 2009-03-28 MartectX $
* @copyright (C)2008-2009, MartectX ( http://mods.martectx.de/ )
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);

$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

include($phpbb_root_path . 'common.' . $phpEx);

$user->session_begin();
$auth->acl($user->data);
$user->setup(array('mods/automatic_dst', 'acp/board'));

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

$mod_name = 'Automatic DST 2';
$version_config_name = 'automatic_dst_2_version';

$options = array(
		'board_timezone1'		=> array('lang' => 'SYSTEM_TIMEZONE',		'validate' => 'string',	'type' => 'select', 'function' => 'tz_select', 'params' => array('{CONFIG_VALUE}', 1), 'explain' => false),
);

$versions = array(
	'2.0.3'	=> array(

		'custom'	=> 'ubm_custom_install',

		'cache_purge' => array(
			array(),
			array('template'),
		),
	),
	'2.0.4'	=> array(

		'custom'	=> 'update_timezome',

		'cache_purge' => array(
			array(),
			array('template'),
		),
	),
);

function ubm_custom_install($action, $version)
{
	global $db, $user, $umil, $phpbb_root_path, $phpEx;

	switch ($version)
	{
		case '2.0.3' :
			switch ($action)
			{
				case 'install' :
				$db->sql_query('ALTER TABLE '  . USERS_TABLE . ' CHANGE user_timezone user_timezone VARCHAR( 255 ) NOT NULL');
				$umil->config_update(array(
						array('board_timezone', request_var('board_timezone1', ''),false),
				));
				$umil->umil_end();
				break;
			}
		break;
	}
}
function update_timezome()
{
	global $db, $user;
$timetable = automatic_dst_get_timetable();

$sql = 'SELECT user_id, user_timezone
	FROM ' . USERS_TABLE;
$result = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($result))
{
	// Only convert entries that are actually stored in the old format
	if (array_key_exists($row['user_timezone'], $timetable))
	{
		// If there's no entry to convert to use the board setting
		$timezone = ($timetable[$row['user_timezone']]) ? $timetable[$row['user_timezone']] : AUTOMATIC_DST_BOARD_TIMEZONE;

		$sql = 'UPDATE ' . USERS_TABLE . "
			SET user_timezone = '$timezone'
			WHERE user_id = " . $row['user_id'];
		$db->sql_query($sql);
	}
}
$db->sql_freeresult($result);
}
// Include the UMIF Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

?>